diff -Narup Mtd-orig/fs/Kconfig mtd/fs/Kconfig
--- Mtd-orig/fs/Kconfig	2005-11-08 02:02:13.000000000 +0100
+++ mtd/fs/Kconfig	2005-11-28 10:19:04.000000000 +0100
@@ -77,73 +77,26 @@ config JFFS2_SUMMARY
 
 	  If unsure, say 'N'.
 
-config JFFS2_COMPRESSION_OPTIONS
-	bool "Advanced compression options for JFFS2"
+config JFFS2_COMPR_CONTROL
+	string "Compression control string"
 	depends on JFFS2_FS
-	default n
+	default "deflate"
 	help
-	  Enabling this option allows you to explicitly choose which
-	  compression modules, if any, are enabled in JFFS2. Removing
-	  compressors and mean you cannot read existing file systems,
-	  and enabling experimental compressors can mean that you
-	  write a file system which cannot be read by a standard kernel.
-
-	  If unsure, you should _definitely_ say 'N'.
-
-config JFFS2_ZLIB
-	bool "JFFS2 ZLIB compression support" if JFFS2_COMPRESSION_OPTIONS
-	select ZLIB_INFLATE
-	select ZLIB_DEFLATE
-	depends on JFFS2_FS
-	default y
-        help
-          Zlib is designed to be a free, general-purpose, legally unencumbered,
-          lossless data-compression library for use on virtually any computer
-          hardware and operating system. See <http://www.gzip.org/zlib/> for
-          further information.
+	  Describes a comma separated list of compressors used for compression.
+	  c1,c2,c3,.. Compress with c1 then c2 then c3...
+	  [c1,c2,c3,...] Compress with all of them and choose the first working
+	  {c1,c2,c3,...} Compress with all of them and choose the one with
+	  the best compression ratio.
+	  These can be mixed but not nested.
 
-          Say 'Y' if unsure.
-
-config JFFS2_RTIME
-	bool "JFFS2 RTIME compression support" if JFFS2_COMPRESSION_OPTIONS
+config JFFS2_COMPR_COMPAT
+	bool "Decompress compatibility with older compression framework"
 	depends on JFFS2_FS
 	default y
-        help
-          Rtime does manage to recompress already-compressed data. Say 'Y' if unsure.
-
-config JFFS2_RUBIN
-	bool "JFFS2 RUBIN compression support" if JFFS2_COMPRESSION_OPTIONS
-	depends on JFFS2_FS
-	default n
-        help
-          RUBINMIPS and DYNRUBIN compressors. Say 'N' if unsure.
-
-choice
-        prompt "JFFS2 default compression mode" if JFFS2_COMPRESSION_OPTIONS
-        default JFFS2_CMODE_PRIORITY
-        depends on JFFS2_FS
-        help
-          You can set here the default compression mode of JFFS2 from
-          the available compression modes. Don't touch if unsure.
-
-config JFFS2_CMODE_NONE
-        bool "no compression"
-        help
-          Uses no compression.
-
-config JFFS2_CMODE_PRIORITY
-        bool "priority"
-        help
-          Tries the compressors in a predefinied order and chooses the first
-          successful one.
-
-config JFFS2_CMODE_SIZE
-        bool "size (EXPERIMENTAL)"
-        help
-          Tries all compressors and chooses the one which has the smallest
-          result.
-
-endchoice
+	help
+	  Add support for decompressing data compressed with the RTIME,
+	  RUBINMIPS and DYNRUBIN compressors and adds decompression
+	  support for ZLIB with full headers.
 
 config JFFS3_FS
 	tristate "Journalling Flash File System v3 (JFFS3) support (EXPERIMENTAL)"
diff -Narup Mtd-orig/fs/jffs2/Makefile.common mtd/fs/jffs2/Makefile.common
--- Mtd-orig/fs/jffs2/Makefile.common	2005-09-15 14:18:12.000000000 +0200
+++ mtd/fs/jffs2/Makefile.common	2005-11-28 10:19:04.000000000 +0100
@@ -12,7 +12,6 @@ jffs2-y	+= symlink.o build.o erase.o bac
 jffs2-y	+= super.o debug.o
 
 jffs2-$(CONFIG_JFFS2_FS_WRITEBUFFER)	+= wbuf.o
-jffs2-$(CONFIG_JFFS2_RUBIN)	+= compr_rubin.o
-jffs2-$(CONFIG_JFFS2_RTIME)	+= compr_rtime.o
-jffs2-$(CONFIG_JFFS2_ZLIB)	+= compr_zlib.o
 jffs2-$(CONFIG_JFFS2_SUMMARY)   += summary.o
+
+jffs2-$(CONFIG_JFFS2_COMPR_COMPAT)	+= compr_compat.o
